diff --git a/gdb/top.c b/gdb/top.c
index 8903a92983..15f99a6a0e 100644
--- a/gdb/top.c
+++ b/gdb/top.c
@@ -543,6 +543,7 @@ execute_command (const char *p, int from_tty)
   struct cmd_list_element *c;
   const char *line;
   const char *cmd_start = p;
+  int is_attach_cmd = 0;
 
   cleanup_if_error = make_bpstat_clear_actions_cleanup ();
   scoped_value_mark cleanup = prepare_execute_command ();
@@ -557,7 +558,7 @@ execute_command (const char *p, int from_tty)
       discard_cleanups (cleanup_if_error);
       return;
     }
-
+  if (strncmp (p, "attach", 6) == 0) is_attach_cmd = 1;
   target_log_command (p);
 
   while (*p == ' ' || *p == '\t')
@@ -641,8 +642,9 @@ execute_command (const char *p, int from_tty)
 		  repeat_arguments);
 	}
     }
-
-  check_frame_language_change ();
+  
+  if (!is_attach_cmd)
+    check_frame_language_change ();
 
   discard_cleanups (cleanup_if_error);
 }
